unit uCommFilter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ActnList, ImgList, Buttons, ToolWin,
  CheckLst, ExtCtrls,
  uCommStruct, StdActns;

type
  TfmComFilter = class(TForm)
    redt1: TRichEdit;
    stat1: TStatusBar;
    actlst1: TActionList;
    act_Monitor: TAction;
    act_Capture: TAction;
    il_Main: TImageList;
    tlb1: TToolBar;
    btnCapture: TToolButton;
    btnCapture1: TToolButton;
    spl1: TSplitter;
    btn1: TToolButton;
    btnExit: TToolButton;
    btnAbout: TToolButton;
    btnClear: TToolButton;
    act_Clear: TAction;
    act_About: TAction;
    act_Exit: TAction;
    pgc1: TPageControl;
    ts1: TTabSheet;
    ts2: TTabSheet;
    chklst1: TCheckListBox;
    chklstCtls: TCheckListBox;
    SearchFind1: TSearchFind;
    SearchFindNext1: TSearchFindNext;
    btn2: TToolButton;
    btn3: TToolButton;
    btn4: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure act_MonitorExecute(Sender: TObject);
    procedure chklst1ClickCheck(Sender: TObject);
    procedure act_ExitExecute(Sender: TObject);
    procedure act_AboutExecute(Sender: TObject);
    procedure act_CaptureExecute(Sender: TObject);
    procedure act_ClearExecute(Sender: TObject);
    procedure chklstCtlsExit(Sender: TObject);
  private
    { Private declarations }
    procedure InitCOMList;

    procedure AddLog(redt: TRichEdit;  AColor: TColor; const Msg: string);
    procedure MonitorCommList;

    procedure OnData(lpBuffer: PENTRY; lpData: PAnsiChar);
    procedure InitIoFilter;
    function InFilter(const ComName: string; ctlValue: DWORD): Boolean;
    procedure ApplyIoctlSetting;


  public
    { Public declarations }
  end;

var
  fmComFilter: TfmComFilter;

const
  DllCommMonitor6 = 'CommMonitor6.dll';
 

//ʼڼ
//lpCallFunc: صfunc, һTOnDataָ
//Boolean True = ɹ  False = ʧ
function InitMonitor(lpCallFunc: TOnData): BOOL; stdcall;  external DllCommMonitor6;
//ݲ״̬, Active(True=ݲ False=ͣݲ)
function ControlCapture(Active: BOOL): BOOL; stdcall; external DllCommMonitor6;

//IoCTL  PIoCtls= TIoCtlsָ
function ControlIoctlArg(PIoCtls: PByte): BOOL; stdcall; external DllCommMonitor6;


//شڶ
function AnyMonitor(lpData: PAnyComName; lpSize: Integer): DWORD; stdcall; external DllCommMonitor6;
//رմڼ, BOOL
function UnMonitor(): BOOL; stdcall;  external DllCommMonitor6;
//
function GetMonitorLastError(): DWORD; stdcall; external DllCommMonitor6;
//Ϣ
function GetMonitorLastErrorMessage(): PChar;   stdcall; external DllCommMonitor6;
//IO Control code
function SerialCtrlCode(ctlCode: DWORD): DWORD;  stdcall;  external DllCommMonitor6;
//PID ҵImageName
function PIDToImageName(PID: DWORD; lpProcessName: PChar): BOOL; stdcall; external DllCommMonitor6;


//ػصfunc
function LOnData(lpBuffer: PENTRY; lpData: Pointer): Integer; stdcall;


function GetIRPName(IOCode: DWORD): string;


implementation

{$R *.dfm}

uses
  Math, Registry;
  
var
  fTotalRead: Integer = 0;
  fTotalWrite: Integer = 0;
  fTotalIrp: Integer = 0;
  fIsMonitored: Boolean = False;
   
  LS_OpenMonitor:      string = '򿪼ʧܣûп';
  LS_NotFoundComm:     string = 'ûзֿõĴ.';
  LS_ControlCapture:   string = 'Ʋ״̬ʧ, 򴮿ڼûп.';

function LOnData(lpBuffer: PENTRY; lpData: Pointer): Integer; stdcall;
begin
  Result := S_OK;
  fmComFilter.OnData(lpBuffer, lpData);
end;
  
procedure TfmComFilter.FormCreate(Sender: TObject);
begin
  self.Caption := IDS_APPTITLE;
  self.redt1.Clear;
  InitCOMList;
  InitIoFilter;
end;


procedure TfmComFilter.ApplyIoctlSetting;
var
   IoArray: TIoCtls;
   sText: string;
   I: Integer;
   Index: Integer;
begin
   FillChar(IoArray, SizeOf(TIoCtls), 0);
   for I := 0 to IOCTL_SERIAL_LSRMST_INSERT - 1 do
   begin
     sText := Format('%s(%s)', [ Trim(GetControlCode(I+1)),  Trim(GetControlCodeCN(I+1))]);
     Index := self.chklstCtls.Items.IndexOf(sText);
     IoArray[I+1] := chklstCtls.Checked[Index];
   end;
   ControlIoctlArg(@IoArray);
end;


function TfmComFilter.InFilter(const ComName: string; ctlValue: DWORD): Boolean;
var
  I: Integer;
  sIRPName: string;
  AItem: TListItem;
begin
  Result := False;
  //COM Filter
  for I := 0 to self.chklst1.Items.Count -1 do
  begin
    if (Pos(ComName, chklst1.Items[I]) = 1) and (chklst1.Checked[I])then
    begin
      Result :=  True;
      Break;
    end;
  end;

  //COM ڹ
  if not Result then Exit;
  //IO filter
  sIRPName := Trim(GetIRPName(ctlValue));

  Result := False;
  for I := 0 to self.chklstCtls.Items.Count -1 do
  begin
    if (Pos(sIRPName, chklstCtls.Items[I]) = 1) and chklstCtls.Checked[I] then
    begin
      Result :=  True;
      Break;
    end;
  end;
end;



procedure TfmComFilter.InitIoFilter;
  procedure AddItem(ACaption, sDestName: string; Check: Boolean; const Code: DWORD);
  begin
    chklstCtls.Items.Add(Format('%s(%s)', [ACaption, sDestName]));
    chklstCtls.Checked[chklstCtls.Items.Count -1] := Check;
  end;
var
  I: Integer;
  Item: TListItem;
begin
  AddItem('IRP_MJ_CREATE',        '򿪴',     True, IRP_MJ_CREATE);
  AddItem('IRP_MJ_CLOSE',         'رմ',     True, IRP_MJ_CLOSE);
  AddItem('IRP_MJ_CLEANUP',       'ر',   False, IRP_MJ_CLEANUP);
  AddItem('IRP_MJ_READ',          'ȡ',     True, IRP_MJ_READ);
  AddItem('IRP_MJ_WRITE',         'д',     True, IRP_MJ_WRITE);
  AddItem('IRP_MJ_FLUSH_BUFFERS', 'ˢ',     False, IRP_MJ_FLUSH_BUFFERS);
  for I := 0 to IOCTL_SERIAL_LSRMST_INSERT - 1 do
    AddItem( Trim(GetControlCode(I+1)),
             Trim(GetControlCodeCN(I+1)),
             ((I + 1) in [IOCTL_SERIAL_SET_BAUD_RATE, IOCTL_SERIAL_SET_QUEUE_SIZE,
                          IOCTL_SERIAL_SET_LINE_CONTROL, IOCTL_SERIAL_SET_CHARS,
                          IOCTL_SERIAL_SET_HANDFLOW, IOCTL_SERIAL_SET_COMMCONFIG,
                          IOCTL_SERIAL_SET_MODEM_CONTROL,
                          IOCTL_SERIAL_SET_DTR, IOCTL_SERIAL_CLR_DTR,
                          IOCTL_SERIAL_SET_RTS, IOCTL_SERIAL_CLR_RTS,
                          IOCTL_SERIAL_SET_XOFF, IOCTL_SERIAL_SET_XON]),
             I + 1
    );
end;


procedure TfmComFilter.InitCOMList;
var
  TS: TStrings;
  sComName, VName: WideString;
  sText: string;
  P: PAnyComName;
  I: Integer;
begin
  with TRegistry.Create do
  try
     RootKey := HKEY_LOCAL_MACHINE;
     if OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM', False) then
     begin
       TS := TStringList.Create;
       try
          GetValueNames(TS);
          for I := 0 to TS.Count -1 do
          begin
            if I > 63 then Break;
            VName := TS[I];
             sComName := ReadString(VName);
             if Trim(sComName) <> '' then
             begin
               sText := Format('%s(%s)', [sComName, VName]);
                //
               if chklst1.Items.IndexOf(sText) < 0 then
               begin
                 DebugArgs('ӣ%s', [sText]);
                  
                 New(P);
                 ZeroMemory(P, SizeOf(P^));
                 P.Active := True;
                 P.Bind := False;
                 System.Move(VName[1], P.ComMapName[0],  Min(SizeOf(P.ComMapName), Length(VName) * SizeOf(WideChar)));
                 System.Move( sComName[1], P.ComName[0], Min(SizeOf(P.ComName), Length(sComName) * SizeOf(WideChar)));
                 chklst1.Items.AddObject(sText, TObject(P));
                 //chklst1.Items[chklst1.Items.Count-1]
                 chklst1.Checked[chklst1.Items.Count-1] := P.Active;
               end else begin
                 DebugArgs('Ѵڣ%s', [sText]);
               end;

             end;
          end;
       finally
         TS.Free;
       end;
       CloseKey;
     end;
  finally
    Free;
  end; 
end;

procedure MonitorAnyComm(P: PAnyComName);
const
  COMM_NONE   = $0001;
  COMM_ACTIVE = $0002;
  COMM_BIND   = $0004;
var
  dwResult: DWORD;
begin
  if P = nil then Exit;
  // P.Active := True;
  dwResult := AnyMonitor(P, SizeOf(TAnyComName));
  
  P.Active :=  dwResult and COMM_ACTIVE = COMM_ACTIVE;
  P.Bind  := dwResult and COMM_BIND = COMM_BIND;
  if dwResult = 0  then
  begin
    MessageBox(Application.Handle, PChar(LS_OpenMonitor), IDS_APPTITLE, MB_OK OR MB_ICONINFORMATION);
    fmComFilter.AddLog(fmComFilter.redt1, clRed, LS_OpenMonitor);
    Exit;
  end;

  if not P.Bind  then
    fmComFilter.AddLog(fmComFilter.redt1, clRed, Format(': %s(%s)Ѵ򿪣ʧ', [P.ComName, P.ComMapName]));
end;

procedure TfmComFilter.act_MonitorExecute(Sender: TObject);
var
  Msg: PChar;
begin
  TAction(Sender).Enabled := False;
  try
    if not fIsMonitored then
    begin
      fTotalRead := 0;
      fTotalWrite := 0;
      fTotalIrp := 0;

      self.InitCOMList;
      if self.chklst1.Items.Count = 0 then
      begin
        Windows.MessageBox(Handle, PChar('ûпɰ󶨵Ĵ'), IDS_APPTITLE, MB_OK OR MB_ICONINFORMATION);
        Exit;
      end;
       
      fIsMonitored := InitMonitor(@LOnData);
    end
    else
    begin
      UnMonitor();
      fIsMonitored := False;
    end;

    if GetMonitorLastError > 0 then
    begin
      Msg := GetMonitorLastErrorMessage();
      if Msg <> nil then
      Windows.MessageBox(Handle, Msg, IDS_APPTITLE, MB_OK or MB_ICONWARNING);
    end;

    act_Monitor.Checked :=  fIsMonitored;
  
    if fIsMonitored then
    begin
      ApplyIoctlSetting;  //ioctl
      MonitorCommList;  //ؼб
      act_Monitor.ImageIndex := 4;
    end
    else
    begin 
      act_Monitor.ImageIndex := 3;
    end;
  finally
    TAction(Sender).Enabled := True;
  end;
end;

procedure TfmComFilter.AddLog(redt: TRichEdit; AColor: TColor;
  const Msg: string);
begin
  try
    if redt.Lines.Count >= 10000 then redt.Clear;
    redt.SelAttributes.Color := AColor;

    if redt.Lines.Count = 0 then
       redt.SelText := Msg
    else
    begin
      
        redt.SelText := #13#10+Msg;
    end;
  except
  end;
end;



procedure TfmComFilter.MonitorCommList;
var
  I: Integer;
  P: PAnyComName;
begin
  for I := 0 to self.chklst1.Items.Count -1 do
  begin
    P := PAnyComName (chklst1.Items.Objects[I]);
    MonitorAnyComm(P);
  end;
end;


procedure TfmComFilter.chklst1ClickCheck(Sender: TObject);
var
  P: PAnyComName;  
begin
  if self.chklst1.ItemIndex < 0 then Exit;
  
  P := PAnyComName (chklst1.Items.Objects[self.chklst1.ItemIndex]);
  if P <> nil then
  begin
    P.Active  := self.chklst1.Checked[self.chklst1.ItemIndex];
    MonitorAnyComm(P);
    self.chklst1.Checked[self.chklst1.ItemIndex] := P.Active;
  end;
  
  //ShowMessage(Format('%s=%s', [self.chklst1.Items[self.chklst1.ItemIndex], BoolToStr(self.chklst1.Checked[self.chklst1.ItemIndex], True)]));
end;

procedure TfmComFilter.act_ExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TfmComFilter.act_AboutExecute(Sender: TObject);
begin
   ShowMessage(IDS_APPTITLE+#13#10+IDS_HOME);
   ShellURL(IDS_HOME);
end;

function GetIRPName(IOCode: DWORD): string;
var
  dwCode: DWORD;
begin
  Result := '';
  case IOCode of
    IRP_MJ_CREATE         : Result := 'IRP_MJ_CREATE';
    IRP_MJ_CLOSE          : Result := 'IRP_MJ_CLOSE';
    IRP_MJ_CLEANUP        : Result := 'IRP_MJ_CLEANUP';
    IRP_MJ_READ           : Result := 'IRP_MJ_READ';
    IRP_MJ_WRITE          : Result := 'IRP_MJ_WRITE';
    IRP_MJ_FLUSH_BUFFERS  : Result := 'IRP_MJ_FLUSH_BUFFERS';
    else begin
      dwCode := SerialCtrlCode(IOCode);
      Result := GetControlCode(dwCode); 
    end;
  end;
end;

procedure TfmComFilter.OnData(lpBuffer: PENTRY; lpData: PAnsiChar);
var
  iOffset, ABufferSize, AReadSize: Integer;
  //dList: TDataArray;
  sLineCmd: string;
  sASC, sHEX, sText, sLogFile: string;
  sImageName: array [0..MAX_PATH-1] of Char;
  I: Integer;
  Item: TListItem;
begin
  if lpBuffer <> nil then
  begin
    //ж
   if not InFilter(lpBuffer.ComName, lpBuffer.ctlValue) then Exit;

    Inc(fTotalIrp);
    case lpBuffer.ctlValue of
      IRP_MJ_WRITE: Inc(fTotalWrite, lpBuffer.dataLength);
      IRP_MJ_READ:  Inc(fTotalRead, lpBuffer.dataLength);
    end;

    if (lpBuffer.ctlValue in [IRP_MJ_WRITE, IRP_MJ_READ]) then
      self.stat1.Panels[1].Text := Format('IRP: %u, Write: %u, Read: %u', [fTotalIrp, fTotalWrite, fTotalRead]);

    // not Capture
    if self.act_Capture.Checked then Exit;

    //////////////////////////////////////////////////////////////

        //ȡ
    FillChar(sImageName, SizeOf(sImageName), 0);
    if not PIDToImageName(lpBuffer.PID, sImageName) then
    begin
      StrFmt(sImageName, 'UNKNOW(%d)', [lpBuffer.PID]);
      //̹رˣ̺󣬹رմڣͻʧ
      DebugArgs('%d, PIDToImageName.ERROR: %s', [lpBuffer.PID, SysUtils.SysErrorMessage(GetLastError)]);
    end;


    sHEX := ''; sASC := ''; sLineCmd := '';
    if (lpBuffer.ctlValue in [IRP_MJ_WRITE, IRP_MJ_READ]) then
    begin
      for I := 0 to lpBuffer.dataLength -1 do
      begin
        sHEX := Format('%s%.2x ', [sHEX, Ord(lpData[I]) ]);
        if Ord(lpData[I]) < 20 then
         sASC :=  Format('%s\#%d', [sASC, Ord(lpData[I]) ])
        else
         sASC := Format('%s%s', [sASC,  Char(lpData[I])] );
      end;
    end else  //
    if (lpBuffer.ctlValue > $400) and (lpBuffer.dataLength > 0) then
    begin
      sLineCmd := GetControlCodeRec( SerialCtrlCode(lpBuffer.ctlValue), lpData^, lpBuffer.dataLength  );
      sText := Format('%s, %s, %s: %s', [ExtractFileName(sImageName), lpBuffer.ComName, GetIRPName(lpBuffer.ctlValue), #13+CHAR(VK_TAB)+sLineCmd+#13]);

      redt1.Tag  := redt1.Tag + 1;
      if redt1.Tag mod 2 = 0 then
        AddLog( self.redt1, clBlue, sText)
      else  AddLog( redt1, clGreen, sText)
    end;

    case lpBuffer.ctlValue of
       IRP_MJ_WRITE: begin
          sText :=  Format('%s, Wirte(%d): %s | %s', [lpBuffer.ComName, lpBuffer.dataLength, sHEX, sASC]);
          AddLog( redt1, clGreen, sText);
       end;
       IRP_MJ_READ: begin
          sText :=  Format('%s, Read(%d): %s | %s', [lpBuffer.ComName, lpBuffer.dataLength, sHEX, sASC]);
          AddLog( redt1, clBlue,  sText);
       end;
    end;
  end;
end;

procedure TfmComFilter.act_CaptureExecute(Sender: TObject);
begin
  if not ControlCapture(act_Capture.Checked) then
  begin
    MessageBox(Handle, PChar(LS_ControlCapture), IDS_APPTITLE, MB_OK OR MB_ICONINFORMATION);
    Exit;
  end;

  act_Capture.Checked := not act_Capture.Checked;
  
  if act_Capture.Checked then
  begin
    act_Capture.ImageIndex := 1;
    //act_Capture.Caption := 'ʼ'
  end
  else
  begin
    act_Capture.ImageIndex := 4;
   // act_Capture.Caption := 'ͣ'
  end;
end;

procedure TfmComFilter.act_ClearExecute(Sender: TObject);
begin
  self.redt1.Clear;
end;

 

procedure TfmComFilter.chklstCtlsExit(Sender: TObject);
begin
  ApplyIoctlSetting;
end;

end.


