unit uCommStruct;
 
interface

uses
  Windows, Messages, SysUtils;

{$DEFINE IS_DEBUG}



const
   DBT_DEVICEREMOVECOMPLETE   = $8004;
   DBT_DEVICEINSERTCOMPLETE   = WM_APP;

   
  IDC_MENU_ABOUT   = $0100;
  IDS_DMAIN        = 'ceiwei';
  IDS_HOME         = 'http://www.'+IDS_DMAIN+'.com';
  IDS_VERSION      = '6.0';
  IDS_APPTITLE     = 'CommMonitor6 SDK Delphi Demo(Call trial 200) v'+IDS_VERSION;

const
  ComNameLen_Max    = 8;
  ComMapNameLen_Max = 64;

   //  IRP CODE
  IRP_MJ_CREATE                   =$00;
  IRP_MJ_CLOSE                    =$02;
  IRP_MJ_READ                     =$03;
  IRP_MJ_WRITE                    =$04;
  IRP_MJ_DEVICE_CONTROL           =$0E;
  IRP_MJ_CLEANUP                  =$12;
  IRP_MJ_MAXIMUM_FUNCTION         =$1B;
  IRP_MJ_FLUSH_BUFFERS            =$09;
  

  //SERIAL CTRL CODE
  IOCTL_SERIAL_SET_BAUD_RATE            =  1;
  IOCTL_SERIAL_SET_QUEUE_SIZE           =  2;
  IOCTL_SERIAL_SET_LINE_CONTROL         =  3;
  IOCTL_SERIAL_SET_BREAK_ON             =  4;
  IOCTL_SERIAL_SET_BREAK_OFF            =  5;
  IOCTL_SERIAL_IMMEDIATE_CHAR           =  6;
  IOCTL_SERIAL_SET_TIMEOUTS             =  7;
  IOCTL_SERIAL_GET_TIMEOUTS             =  8;
  IOCTL_SERIAL_SET_DTR                  =  9;
  IOCTL_SERIAL_CLR_DTR                  =  10;
  IOCTL_SERIAL_RESET_DEVICE             =  11;
  IOCTL_SERIAL_SET_RTS                  =  12;
  IOCTL_SERIAL_CLR_RTS                  =  13;
  IOCTL_SERIAL_SET_XOFF                 =  14;
  IOCTL_SERIAL_SET_XON                  =  15;
  IOCTL_SERIAL_GET_WAIT_MASK            =  16;
  IOCTL_SERIAL_SET_WAIT_MASK            =  17;
  IOCTL_SERIAL_WAIT_ON_MASK             =  18;
  IOCTL_SERIAL_PURGE                    =  19;
  IOCTL_SERIAL_GET_BAUD_RATE            =  20;
  IOCTL_SERIAL_GET_LINE_CONTROL         =  21;
  IOCTL_SERIAL_GET_CHARS                =  22;
  IOCTL_SERIAL_SET_CHARS                =  23;
  IOCTL_SERIAL_GET_HANDFLOW             =  24;
  IOCTL_SERIAL_SET_HANDFLOW             =  25;
  IOCTL_SERIAL_GET_MODEMSTATUS          =  26;
  IOCTL_SERIAL_GET_COMMSTATUS           =  27;
  IOCTL_SERIAL_XOFF_COUNTER             =  28;
  IOCTL_SERIAL_GET_PROPERTIES           =  29;
  IOCTL_SERIAL_GET_DTRRTS               =  30;
  IOCTL_SERIAL_LSRMST_INSERT            =  31;
  IOCTL_SERIAL_CONFIG_SIZE              =  32;
  IOCTL_SERIAL_GET_COMMCONFIG           =  33;
  IOCTL_SERIAL_SET_COMMCONFIG           =  34;
  IOCTL_SERIAL_GET_STATS                =  35;
  IOCTL_SERIAL_CLEAR_STATS              =  36;
  IOCTL_SERIAL_GET_MODEM_CONTROL        =  37;
  IOCTL_SERIAL_SET_MODEM_CONTROL        =  38;
  IOCTL_SERIAL_SET_FIFO_CONTROL         =  39;


/////////////////////////
  SERIAL_DTR_MASK           = $03;
  SERIAL_DTR_CONTROL        = $01;
  SERIAL_DTR_HANDSHAKE      = $02;
  SERIAL_CTS_HANDSHAKE      = $08;
  SERIAL_DSR_HANDSHAKE      = $10;
  SERIAL_DCD_HANDSHAKE      = $20;
  SERIAL_OUT_HANDSHAKEMASK  = $38;
  SERIAL_DSR_SENSITIVITY    = $40;
  SERIAL_ERROR_ABORT        = $80000000;
  SERIAL_CONTROL_INVALID    = $7fffff84;
  SERIAL_AUTO_TRANSMIT      = $01;
  SERIAL_AUTO_RECEIVE       = $02;
  SERIAL_ERROR_CHAR         = $04;
  SERIAL_NULL_STRIPPING     = $08;
  SERIAL_BREAK_CHAR         = $10;
  SERIAL_RTS_MASK           = $c0;
  SERIAL_RTS_CONTROL        = $40;
  SERIAL_RTS_HANDSHAKE      = $80;
  SERIAL_TRANSMIT_TOGGLE    = $c0;
  SERIAL_XOFF_CONTINUE      = $80000000;
  SERIAL_FLOW_INVALID       = $7fffff20;



  SERIAL_TX_WAITING_FOR_CTS      = $00000001;
  SERIAL_TX_WAITING_FOR_DSR      = $00000002;
  SERIAL_TX_WAITING_FOR_DCD      = $00000004;
  SERIAL_TX_WAITING_FOR_XON      = $00000008;
  SERIAL_TX_WAITING_XOFF_SENT    = $00000010;
  SERIAL_TX_WAITING_ON_BREAK     = $00000020;
  SERIAL_RX_WAITING_FOR_DSR      = $00000040;


  SERIAL_ERROR_BREAK             = $00000001;
  SERIAL_ERROR_FRAMING           = $00000002;
  SERIAL_ERROR_OVERRUN           = $00000004;
  SERIAL_ERROR_QUEUEOVERRUN      = $00000008;
  SERIAL_ERROR_PARITY            = $00000010;


type
 TIoCtls  = array[IOCTL_SERIAL_SET_BAUD_RATE..IOCTL_SERIAL_LSRMST_INSERT] of Boolean;

 TAnyComName = packed record
    Active:  Boolean;  //״̬
    Bind:    Boolean;  //״̬ ɹ ʧ
    ComMapName: array[0..ComMapNameLen_Max-1] of WideChar;
    ComName:    array[0..ComNameLen_Max-1] of WideChar;
  end;  
  PAnyComName = ^TAnyComName;


  TENTRY = packed record
     seq:       DWORD;      //
     dateTime:  DWORD;      //ʱ
	   ctlValue:  DWORD;			//Comm IOCTL Code	
     PID:       DWORD;		  //ڽPID
	   ComName:   array [0..ComNameLen_Max-1] of WideChar;		//Comm Name     COM1 COM2 .....
	   dataLength: Integer;   //ݳ
  end;
  PENTRY = ^TENTRY;

  //ݰص
  TOnData = function(lpBuffer: PENTRY; lpData: Pointer): Integer; stdcall;

  TDataArray = array of Byte;
 

procedure DebugLn(const sOutput: string);
procedure Debug(const sOutput: string);
procedure DebugArgs(const sFormat: string; Args: array of const);

//ComڵControl Code name
function GetControlCode(dwCode: DWORD): string;
function GetControlCodeCN(dwCode: DWORD): string;

//Control Code ýṹϢ
function GetControlCodeRec(dwCode: DWORD; const Buffer; dwSize: Integer): string;
 


procedure SaveLog(const FileName, sLog: string);

function IIFStr(const a, b: string): string;


function ShellExpoloer(sFileName: string): Boolean;

function ShellURL(sURL: string): Boolean;

implementation

uses
  ShellAPI;



type
  ULONG = DWORD;
  UCHAR = Byte;


  TSERIAL_QUEUE_SIZE = packed record
    InSize: ULONG;
    OutSize: ULONG ;
  end;
  PSERIAL_QUEUE_SIZE = ^TSERIAL_QUEUE_SIZE;

  TSERIAL_LINE_CONTROL = packed record
    StopBits: UCHAR;
    Parity: UCHAR;
    WordLength: UCHAR ;
  end;
  PSERIAL_LINE_CONTROL = ^TSERIAL_LINE_CONTROL;



   TSERIAL_CHARS = packed record
     EofChar:        UCHAR;
     ErrorChar:      UCHAR;
     BreakChar:      UCHAR;
     EventChar:      UCHAR;
     XonChar:        UCHAR;
     XoffChar:       UCHAR;
   end;
   PSERIAL_CHARS = ^TSERIAL_CHARS;

   TSERIAL_HANDFLOW = packed record
     ControlHandShake: ULONG;
     FlowReplace:      ULONG;
     XonLimit:         Integer;
     XoffLimit:        Integer;  //LONG
   end;
  PSERIAL_HANDFLOW = ^TSERIAL_HANDFLOW;

  TSERIAL_STATUS  = packed record
     Errors: DWORD;
     HoldReasons: DWORD;
     AmountInInQueue: DWORD;
     AmountInOutQueue: DWORD;
     EofReceived: BOOLEAN;
     WaitForImmediate:  BOOLEAN;
  end;
  PSERIAL_STATUS = ^TSERIAL_STATUS;



  
function ShellURL(sURL: string): Boolean;
begin
  ShellExecute(0, 'open', PChar(sURL), nil, nil, SW_SHOW);
end;

function ShellExpoloer(sFileName: string): Boolean;
begin

end;

function IIFStr(const a, b: string): string;
begin
  if a = '' then result := b else result := a;  
end;


procedure SaveLog(const FileName, sLog: string);
var
  TF: TextFile;
begin
  System.AssignFile(TF, FileName);
  try
    try
      if FileExists(FileName) then
        System.Append(TF)
      else System.Rewrite(TF);
      System.Write(TF, sLog);
    except
    end;
  finally
    System.CloseFile(TF);
  end;
end;


procedure DebugLn(const sOutput: string);
begin
  Debug(sOutput+#13#10);
end;

procedure Debug(const sOutput: string);
begin
   {$IFDEF IS_DEBUG}
   Windows.OutputDebugString(PChar(sOutput));
   {$ENDIF}
end;

procedure DebugArgs(const sFormat: string; Args: array of const);
begin
  DebugLn(Format(sFormat, Args));
end;



function GetControlCodeCN(dwCode: DWORD): string;
begin
  case dwCode  of
    IOCTL_SERIAL_SET_BAUD_RATE         : Result := 'ò';
    IOCTL_SERIAL_SET_QUEUE_SIZE        : Result := 'ôڻС   ';

    IOCTL_SERIAL_SET_BREAK_ON          : Result := 'Break On     ';
    IOCTL_SERIAL_SET_BREAK_OFF         : Result := 'Break Off    ';
    IOCTL_SERIAL_IMMEDIATE_CHAR        : Result := 'ͼʱַ   ';

    IOCTL_SERIAL_SET_TIMEOUTS          : Result := 'óʱ     ';
    IOCTL_SERIAL_GET_TIMEOUTS          : Result := 'ȡʱϢ    ';
    IOCTL_SERIAL_SET_DTR               : Result := 'DTR          ';
    IOCTL_SERIAL_CLR_DTR               : Result := 'DTR          ';
    IOCTL_SERIAL_RESET_DEVICE          : Result := 'ô     ';
    IOCTL_SERIAL_SET_RTS               : Result := 'RTS          ';
    IOCTL_SERIAL_CLR_RTS               : Result := 'RTS          ';
    IOCTL_SERIAL_SET_XOFF              : Result := 'XOFF         ';
    IOCTL_SERIAL_SET_XON               : Result := 'XON          ';
    IOCTL_SERIAL_GET_WAIT_MASK         : Result := 'ȡ¼    ';
    IOCTL_SERIAL_SET_WAIT_MASK         : Result := '¼     ';
    IOCTL_SERIAL_WAIT_ON_MASK          : Result := 'ȴ¼On     ';
    IOCTL_SERIAL_PURGE                 : Result := '            ';
    IOCTL_SERIAL_GET_BAUD_RATE         : Result := 'ȡ';
    IOCTL_SERIAL_GET_LINE_CONTROL      : Result := 'ȡп ';
    IOCTL_SERIAL_SET_LINE_CONTROL      : Result := 'п ';
    IOCTL_SERIAL_GET_CHARS             : Result := 'ȡַָ           ';
    IOCTL_SERIAL_SET_CHARS             : Result := 'ַָ           ';
    IOCTL_SERIAL_GET_HANDFLOW          : Result := 'ȡϢ     ';
    IOCTL_SERIAL_SET_HANDFLOW          : Result := 'Ϣ     ';
    IOCTL_SERIAL_GET_MODEMSTATUS       : Result := 'ȡMODEM״̬  ';
    IOCTL_SERIAL_GET_COMMSTATUS        : Result := 'ȡ״̬   ';
    IOCTL_SERIAL_XOFF_COUNTER          : Result := 'XOFF     ';
    IOCTL_SERIAL_GET_PROPERTIES        : Result := 'ȡ   ';
    IOCTL_SERIAL_GET_DTRRTS            : Result := 'ȡDTR RTS       ';
    ////////////////////////
    IOCTL_SERIAL_LSRMST_INSERT         : Result := 'LSRMST    ';
    IOCTL_SERIAL_CONFIG_SIZE           : Result := 'ȡôС      ';
    IOCTL_SERIAL_GET_COMMCONFIG        : Result := 'ȡϢ   ';
    IOCTL_SERIAL_SET_COMMCONFIG        : Result := 'ôϢ   ';
    IOCTL_SERIAL_GET_STATS             : Result := 'ȡϢ        ';
    IOCTL_SERIAL_CLEAR_STATS           : Result := 'Ϣ      ';
    IOCTL_SERIAL_GET_MODEM_CONTROL     : Result := 'ȡ MODE ';
    IOCTL_SERIAL_SET_MODEM_CONTROL     : Result := 'MODE ';
    IOCTL_SERIAL_SET_FIFO_CONTROL      : Result := ' FIFO  ';
  end;
  if Result = '' then Result := Format('UNKNOWN COMMAND CODE: %d', [dwCode]);
end;


function CheckAND(dwCode, csCode: DWORD): Boolean;
begin
  Result := (dwCode and csCode) = csCode;
end;


function GetLINE_CONTROL(P: PSERIAL_LINE_CONTROL): string;
var
  Bcd: DCB;
begin
  Result := Format('WordLength: %d'#13, [P.WordLength]);
  case P.StopBits of
    ONESTOPBIT: Result := Result   + #9'StopBits: 1'#13;
    ONE5STOPBITS: Result := Result + #9'StopBits: 1.5'#13;
    TWOSTOPBITS: Result := Result +  #9'StopBits: 2'#13;
  end;

  case P.Parity of
    NOPARITY:    Result:= Result + #9'ParityNone '#13;
    ODDPARITY:   Result:= Result + #9'ParityO '#13;
    EVENPARITY:  Result:= Result + #9'ParityE ż'#13;
    MARKPARITY:  Result:= Result + #9'ParityM ־'#13;
    SPACEPARITY: Result:= Result + #9'ParityS ո'#13;
  end;
end;

function GetBAUD_RATE(dwCode: DWORD): string;
begin
  Result := Format('%d', [dwCode]);
end;

function GetControlCodeRec(dwCode: DWORD; const Buffer; dwSize: Integer): string;
var
  I: Integer;
  P: PAnsiChar;
  HandFlow: PSERIAL_HANDFLOW;
begin
  try
    case dwCode  of
      IOCTL_SERIAL_GET_BAUD_RATE,
      IOCTL_SERIAL_SET_BAUD_RATE         : Result := Format('%s', [GetBAUD_RATE(PDWORD(@Buffer)^)]);

      IOCTL_SERIAL_SET_QUEUE_SIZE        : Result := Format('QueueSize.InSize: %d, QueueSize.OutSize: %d', [PSERIAL_QUEUE_SIZE(@Buffer)^.InSize, PSERIAL_QUEUE_SIZE(@Buffer)^.OutSize]);

      IOCTL_SERIAL_GET_LINE_CONTROL,
      IOCTL_SERIAL_SET_LINE_CONTROL      : Result := Format('%s', [GetLINE_CONTROL(PSERIAL_LINE_CONTROL(@Buffer))]);

      IOCTL_SERIAL_SET_BREAK_ON          : Result := 'set Break On';
      IOCTL_SERIAL_SET_BREAK_OFF         : Result := 'Set Break Off';
      IOCTL_SERIAL_IMMEDIATE_CHAR        : Result := Format('%s', [Char(PByte(@Buffer)^)]);

      IOCTL_SERIAL_SET_TIMEOUTS,
      IOCTL_SERIAL_GET_TIMEOUTS          : Result := Format('ReadIntervalTimeout: %d, ReadTotalTimeoutMultiplier: %d, ReadTotalTimeoutConstant: %d, WriteTotalTimeoutMultiplier: %d,  WriteTotalTimeoutConstant: %d',
          [PCommTimeouts(@Buffer)^.ReadIntervalTimeout, PCommTimeouts(@Buffer)^.ReadTotalTimeoutMultiplier,
           PCommTimeouts(@Buffer)^.ReadTotalTimeoutConstant,
           PCommTimeouts(@Buffer)^.WriteTotalTimeoutMultiplier, PCommTimeouts(@Buffer)^.WriteTotalTimeoutConstant
          ]);



      IOCTL_SERIAL_SET_DTR               : Result := 'Set DTR';
      IOCTL_SERIAL_CLR_DTR               : Result := 'Clear DTR';
      IOCTL_SERIAL_RESET_DEVICE          : Result := 'Reset Device';
      IOCTL_SERIAL_SET_RTS               : Result := 'Set RTS          ';
      IOCTL_SERIAL_CLR_RTS               : Result := 'Clear RTS          ';
      IOCTL_SERIAL_SET_XOFF              : Result := 'Set XOFF         ';
      IOCTL_SERIAL_SET_XON               : Result := 'Set XON          ';


      IOCTL_SERIAL_GET_WAIT_MASK,
      IOCTL_SERIAL_SET_WAIT_MASK,
      IOCTL_SERIAL_WAIT_ON_MASK          : Result := Format('%d', [PDWORD(@Buffer)^]);
      IOCTL_SERIAL_PURGE                 : Result := Format('%d', [PDWORD(@Buffer)^]);

      IOCTL_SERIAL_SET_CHARS,
      IOCTL_SERIAL_GET_CHARS             : Result := Format('Chars Eof: %d, Error: %d, break: %d, Event: %d, Xon: %d, Xoff: %d',
      [PSERIAL_CHARS(@Buffer)^.EofChar,
       PSERIAL_CHARS(@Buffer)^.ErrorChar,
       PSERIAL_CHARS(@Buffer)^.BreakChar,
       PSERIAL_CHARS(@Buffer)^.EventChar,
       PSERIAL_CHARS(@Buffer)^.XonChar,
       PSERIAL_CHARS(@Buffer)^.XoffChar
      ]);

      IOCTL_SERIAL_GET_HANDFLOW,
      IOCTL_SERIAL_SET_HANDFLOW          :
      begin
         HandFlow := @Buffer;
         Result := '';
         if CheckAND(HandFlow.ControlHandShake, SERIAL_CTS_HANDSHAKE) then
           Result := Result+'DCB.fOutxCtsFlow=TRUE'#13#9;
         if CheckAND(HandFlow.ControlHandShake, SERIAL_DSR_HANDSHAKE) then
           Result := Result+'DCB.fOutxDsrFlow=TRUE'#13#9;
         if CheckAND(HandFlow.ControlHandShake, SERIAL_ERROR_ABORT) then
           Result := Result+'DCB.fAbortOnError=TRUE'#13#9;


        if CheckAND(HandFlow.FlowReplace, SERIAL_AUTO_TRANSMIT) then
           Result := Result+'DCB.fOutX=TRUE'#13#9;
        if CheckAND(HandFlow.FlowReplace, SERIAL_AUTO_RECEIVE) then
           Result := Result+'DCB.fInX=TRUE'#13#9;

        if CheckAND(HandFlow.FlowReplace, SERIAL_NULL_STRIPPING) then
           Result := Result+'DCB.fNull=TRUE'#13#9;
        if CheckAND(HandFlow.FlowReplace, SERIAL_ERROR_CHAR) then
           Result := Result+'DCB.fErrorChar=TRUE'#13#9;
        if CheckAND(HandFlow.FlowReplace, SERIAL_XOFF_CONTINUE) then
           Result := Result+'DCB.fTXContinueOnXoff=TRUE'#13#9;

        case HandFlow.FlowReplace and SERIAL_RTS_MASK of
          0:                        Result := Result+ 'DCB.fRtsControl=RTS_CONTROL_DISABLE'#13#9;
          SERIAL_RTS_CONTROL:       Result := Result+ 'DCB.fRtsControl=RTS_CONTROL_ENABLE'#13#9;
          SERIAL_RTS_HANDSHAKE:     Result := Result+ 'DCB.fRtsControl=RTS_CONTROL_HANDSHAKE'#13#9;
          SERIAL_TRANSMIT_TOGGLE:   Result := Result+ 'DCB.fRtsControl=RTS_CONTROL_TOGGLE'#13#9;
        end;

        case HandFlow.ControlHandShake and SERIAL_DTR_MASK of
                      0:          Result := Result+ 'DCB.fDtrControl=DTR_CONTROL_DISABLE'#13#9;
          SERIAL_DTR_CONTROL:     Result := Result+ 'DCB.fDtrControl=DTR_CONTROL_ENABLE'#13#9;
          SERIAL_DTR_HANDSHAKE:   Result := Result+ 'DCB.fDtrControl=DTR_CONTROL_HANDSHAKE'#13#9;
        end;

        if CheckAND(HandFlow.ControlHandShake, SERIAL_DSR_SENSITIVITY) then
           Result := Result+'DCB.fDsrSensitivity=TRUE'#13#9
        else Result := Result+'DCB.fDsrSensitivity=FALSE'#13#9;

        Result := Result+ Format('DCB->XonLim: %d'#13#9'DCB->XoffLim: %d', [HandFlow.XonLimit, HandFlow.XoffLimit]);
      end;

      IOCTL_SERIAL_GET_MODEMSTATUS       : Result := Format('Modem Status: %d', [PDWORD(@Buffer)^]);
      IOCTL_SERIAL_GET_COMMSTATUS        : Result := Format('COMMSTATUS  Errors: %u, HoldReasons: %u,  AmountInInQueue: %u, AmountInOutQueue: %u,  EofReceived: %s, WaitForImmediate: %s',
      [PSERIAL_STATUS(@Buffer)^.Errors,
       PSERIAL_STATUS(@Buffer)^.HoldReasons,
       PSERIAL_STATUS(@Buffer)^.AmountInInQueue,
       PSERIAL_STATUS(@Buffer)^.AmountInOutQueue,
       BoolToStr(PSERIAL_STATUS(@Buffer)^.EofReceived, True),
       BoolToStr(PSERIAL_STATUS(@Buffer)^.WaitForImmediate, True)
      ]);

      IOCTL_SERIAL_XOFF_COUNTER          : Result := '';

      IOCTL_SERIAL_GET_PROPERTIES        : Result :=
      Format(  'wPacketLength: %d'#13#9+
               'wPacketVersion: %d'#13#9+
               'dwServiceMask: %d'#13#9+
               'dwMaxTxQueue: %d'#13#9+
               'dwMaxRxQueue: %d'#13#9+
               'dwMaxBaud: %d'#13#9+
               'dwProvSubType: %d'#13#9+
               'dwProvCapabilities: %d'#13#9+
               'dwSettableParams: %d'#13#9+
               'dwSettableBaud: %d'#13#9+
               'wSettableData: %d'#13#9+
               'wSettableStopParity: %d'#13#9+
               'dwCurrentTxQueue: %d'#13#9+
               'dwCurrentRxQueue: %d'#13#9+
               'dwProvSpec1: %d'#13#9+
               'dwProvSpec2: %d',
      [PCommProp(@Buffer)^.wPacketLength,
       PCommProp(@Buffer)^.wPacketVersion,
       PCommProp(@Buffer)^.dwServiceMask,
       PCommProp(@Buffer)^.dwMaxTxQueue,
       PCommProp(@Buffer)^.dwMaxRxQueue,
       PCommProp(@Buffer)^.dwMaxBaud,
       PCommProp(@Buffer)^.dwProvSubType,
       PCommProp(@Buffer)^.dwProvCapabilities,
       PCommProp(@Buffer)^.dwSettableParams,
       PCommProp(@Buffer)^.dwSettableBaud,
       PCommProp(@Buffer)^.wSettableData,
       PCommProp(@Buffer)^.wSettableStopParity,
       PCommProp(@Buffer)^.dwCurrentTxQueue,
       PCommProp(@Buffer)^.dwCurrentRxQueue,
       PCommProp(@Buffer)^.dwProvSpec1,
       PCommProp(@Buffer)^.dwProvSpec2
       //PCommProp(@Buffer)^.wcProvChar
      ]);


      IOCTL_SERIAL_GET_DTRRTS            : Result := '';
      ////////////////////////
      IOCTL_SERIAL_LSRMST_INSERT         : Result := '';
      IOCTL_SERIAL_CONFIG_SIZE           : Result := Format('%d', [PDWORD(@Buffer)^]);
      IOCTL_SERIAL_GET_COMMCONFIG,
      IOCTL_SERIAL_SET_COMMCONFIG        : Result :=
      Format('wVersion: %d, dwProviderSubType: %d, dwProviderOffset: %d, DCB: See GetCommSatae/SetCommSatae',
      [
      PCommConfig(@Buffer)^.wVersion,
      PCommConfig(@Buffer)^.dwProviderSubType,
      PCommConfig(@Buffer)^.dwProviderOffset
      ]);
      IOCTL_SERIAL_GET_STATS             : Result := '';
      IOCTL_SERIAL_CLEAR_STATS           : Result := '';
      IOCTL_SERIAL_GET_MODEM_CONTROL     : Result := '';
      IOCTL_SERIAL_SET_MODEM_CONTROL     : Result := '';
      IOCTL_SERIAL_SET_FIFO_CONTROL      : Result := '';
      else Result := Format('UNKNOWN COMMAND CODE: %d', [dwCode]);
    end;

    if Result = '' then
    for I := 0 to dwSize-1 do
    begin
      P := @Buffer;
      Result := Result + Format('%.2x', [Ord(P[I])]);
    end;
  except on E: Exception do
    Result := Format('Convert CODE: %d ERROR: %s', [dwCode, E.Message]);
  end;
end;

function GetControlCode(dwCode: DWORD): string;
begin
  case dwCode  of
    IOCTL_SERIAL_SET_BAUD_RATE         : Result := 'IOCTL_SET_BAUD_RATE    ';
    IOCTL_SERIAL_SET_QUEUE_SIZE        : Result := 'IOCTL_SET_QUEUE_SIZE   ';
    IOCTL_SERIAL_SET_LINE_CONTROL      : Result := 'IOCTL_SET_LINE_CONTROL ';
    IOCTL_SERIAL_SET_BREAK_ON          : Result := 'IOCTL_SET_BREAK_ON     ';
    IOCTL_SERIAL_SET_BREAK_OFF         : Result := 'IOCTL_SET_BREAK_OFF    ';
    IOCTL_SERIAL_IMMEDIATE_CHAR        : Result := 'IOCTL_IMMEDIATE_CHAR   ';
    IOCTL_SERIAL_SET_TIMEOUTS          : Result := 'IOCTL_SET_TIMEOUTS     ';
    IOCTL_SERIAL_GET_TIMEOUTS          : Result := 'IOCTL_GET_TIMEOUTS     ';
    IOCTL_SERIAL_SET_DTR               : Result := 'IOCTL_SET_DTR          ';
    IOCTL_SERIAL_CLR_DTR               : Result := 'IOCTL_CLR_DTR          ';
    IOCTL_SERIAL_RESET_DEVICE          : Result := 'IOCTL_RESET_DEVICE     ';
    IOCTL_SERIAL_SET_RTS               : Result := 'IOCTL_SET_RTS          ';
    IOCTL_SERIAL_CLR_RTS               : Result := 'IOCTL_CLR_RTS          ';
    IOCTL_SERIAL_SET_XOFF              : Result := 'IOCTL_SET_XOFF         ';
    IOCTL_SERIAL_SET_XON               : Result := 'IOCTL_SET_XON          ';
    IOCTL_SERIAL_GET_WAIT_MASK         : Result := 'IOCTL_GET_WAIT_MASK    ';
    IOCTL_SERIAL_SET_WAIT_MASK         : Result := 'IOCTL_SET_WAIT_MASK    ';
    IOCTL_SERIAL_WAIT_ON_MASK          : Result := 'IOCTL_WAIT_ON_MASK     ';
    IOCTL_SERIAL_PURGE                 : Result := 'IOCTL_PURGE            ';
    IOCTL_SERIAL_GET_BAUD_RATE         : Result := 'IOCTL_GET_BAUD_RATE    ';
    IOCTL_SERIAL_GET_LINE_CONTROL      : Result := 'IOCTL_GET_LINE_CONTROL ';
    IOCTL_SERIAL_GET_CHARS             : Result := 'IOCTL_GET_CHARS        ';
    IOCTL_SERIAL_SET_CHARS             : Result := 'IOCTL_SET_CHARS        ';
    IOCTL_SERIAL_GET_HANDFLOW          : Result := 'IOCTL_GET_HANDFLOW     ';
    IOCTL_SERIAL_SET_HANDFLOW          : Result := 'IOCTL_SET_HANDFLOW     ';
    IOCTL_SERIAL_GET_MODEMSTATUS       : Result := 'IOCTL_GET_MODEMSTATUS  ';
    IOCTL_SERIAL_GET_COMMSTATUS        : Result := 'IOCTL_GET_COMMSTATUS   ';
    IOCTL_SERIAL_XOFF_COUNTER          : Result := 'IOCTL_XOFF_COUNTER     ';
    IOCTL_SERIAL_GET_PROPERTIES        : Result := 'IOCTL_GET_PROPERTIES   ';
    IOCTL_SERIAL_GET_DTRRTS            : Result := 'IOCTL_GET_DTRRTS       ';
    ////////////////////////
    IOCTL_SERIAL_LSRMST_INSERT         : Result := 'IOCTL_LSRMST_INSERT    ';
    IOCTL_SERIAL_CONFIG_SIZE           : Result := 'IOCTL_CONFIG_SIZE      ';
    IOCTL_SERIAL_GET_COMMCONFIG        : Result := 'IOCTL_GET_COMMCONFIG   ';
    IOCTL_SERIAL_SET_COMMCONFIG        : Result := 'IOCTL_SET_COMMCONFIG   ';
    IOCTL_SERIAL_GET_STATS             : Result := 'IOCTL_GET_STATS        ';
    IOCTL_SERIAL_CLEAR_STATS           : Result := 'IOCTL_CLEAR_STATS      ';
    IOCTL_SERIAL_GET_MODEM_CONTROL     : Result := 'IOCTL_GET_MODEM_CONTROL';
    IOCTL_SERIAL_SET_MODEM_CONTROL     : Result := 'IOCTL_SET_MODEM_CONTROL';
    IOCTL_SERIAL_SET_FIFO_CONTROL      : Result := 'IOCTL_SET_FIFO_CONTROL ';
  end;
  if Result = '' then Result := Format('UNKNOWN COMMAND CODE: %d', [dwCode]);
end;
 
end.
